"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var vm_datastore_dao_1 = require("../../dao/vm-datastore-dao");
var _ = require("lodash");
var VmDatastoreTreeController = (function () {
    function VmDatastoreTreeController() {
        this.ancestors = [];
        this.vmDatastoreDao = new vm_datastore_dao_1.VmDatastoreDao();
    }
    VmDatastoreTreeController.prototype.open = function (selectedPath) {
        var _this = this;
        selectedPath = selectedPath || '/';
        var promise;
        if (!this.entry || (selectedPath !== this.entry.path && (!_.find(this.entry.children, { path: selectedPath }) ||
            _.find(this.entry.children, { path: selectedPath }).type === 'DIRECTORY'))) {
            promise = this.vmDatastoreDao.listDiskTargetsWithType(this.type, this.datastoreId, selectedPath).then(function (entries) { return Promise.all(_.map(entries, function (entry) {
                return entry.type === 'DIRECTORY' ?
                    _this.vmDatastoreDao.listDiskTargetsWithType(_this.type, _this.datastoreId, entry.path)
                        .then(function (children) { return ([entry, children]); }) :
                    [entry, []];
            })); }).then(function (entries) {
                if (_this.parent && selectedPath === _this.parent.path) {
                    _this.entry = _.assign(_this.ancestors.pop(), { children: _this.getChildrenFromEntries(entries) });
                }
                else {
                    var parent_1 = _this.entry, child = parent_1 && _.find(parent_1.children, { path: selectedPath }), type = child ? child.type : 'DIRECTORY';
                    _this.ancestors.push(parent_1);
                    _this.entry = {
                        name: _.last(_.split(selectedPath, '/')) + (type === 'DIRECTORY' ? '/' : ''),
                        path: selectedPath,
                        children: _this.getChildrenFromEntries(entries),
                        parent: parent_1,
                        type: type
                    };
                }
                _this.parent = _.last(_this.ancestors);
            });
        }
        return (promise || Promise.resolve()).then(function (x) { return _this.entry; });
    };
    VmDatastoreTreeController.prototype.getChildrenFromEntries = function (entries) {
        return _.map(entries, function (entry) { return ({
            name: _.last(_.split(entry[0].path, '/')),
            path: entry[0].path,
            type: entry[0].type,
            original: entry[0],
            children: entry[1]
        }); });
    };
    return VmDatastoreTreeController;
}());
exports.VmDatastoreTreeController = VmDatastoreTreeController;
