"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_dao_1 = require("./abstract-dao");
var model_1 = require("../model");
var DockerImageDao = (function (_super) {
    __extends(DockerImageDao, _super);
    function DockerImageDao() {
        return _super.call(this, model_1.Model.DockerImage, {
            eventName: 'entity-subscriber.docker.image.changed'
        }) || this;
    }
    DockerImageDao.prototype.readme = function (dockerImageName) {
        return this.middlewareClient.callRpcMethod('docker.image.readme', [dockerImageName]);
    };
    DockerImageDao.prototype.pullToHost = function (imageName, hostId) {
        return this.middlewareClient.submitTask('docker.image.pull', [imageName, hostId]);
    };
    DockerImageDao.prototype.deleteFromHost = function (imageId, hostId) {
        return this.middlewareClient.submitTask('docker.image.delete', [imageId, hostId]);
    };
    return DockerImageDao;
}(abstract_dao_1.AbstractDao));
exports.DockerImageDao = DockerImageDao;
