"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immutable = require("immutable");
function deleteObject(previousState, action) {
    var type = action.meta.type, id = action.meta.id, typeState = previousState.has(type) ? previousState.get(type).delete(id) : immutable.Map(), streamStates = previousState.get('streams');
    streamStates.forEach(function (streamState, streamId) {
        if (streamState.get('type') === type) {
            var dataMap = streamState.get('data'), index = dataMap.findKey(function (value) { return value.get('id') === id; });
            if (index !== void 0) {
                streamStates = streamStates.set(streamId, streamState.set('data', dataMap.delete(index)));
            }
        }
    });
    return previousState.set(type, typeState).set('streams', streamStates);
}
exports.deleteObject = deleteObject;
