"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var immutable = require("immutable");
var Task_1 = require("../model/Task");
var MAX_TASK_COUNT = 100;
function saveObject(previousState, action) {
    var type = action.meta.type, id = action.meta.id, object = immutable.fromJS(action.payload)
        .set('_stableId', id)
        .set('_objectType', type), typeState = previousState.has(type) ? previousState.get(type).set(id, object) : immutable.Map().set(id, object), streamStates = previousState.get('streams');
    streamStates.forEach(function (streamState, streamId) {
        if (streamState.get('type') === type) {
            var key = streamStates.get(streamId).get('data').findKey(function (value) {
                return value.get('id') === id;
            });
            if (key > -1) {
                streamStates = streamStates.set(streamId, streamState.set('data', streamState.get('data').set(key, object)));
            }
            else {
                streamStates = streamStates.set(streamId, streamState.set('data', streamState.get('data').push(object)));
            }
        }
    });
    if (type === Task_1.Task.getClassName()) {
        if (typeState.size > MAX_TASK_COUNT) {
            typeState = typeState.takeLast(MAX_TASK_COUNT);
        }
    }
    return previousState.set(type, typeState).set('streams', streamStates);
}
exports.saveObject = saveObject;
