"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var network_interface_dao_1 = require("../dao/network-interface-dao");
var NetworkInterfaceRepository = (function (_super) {
    __extends(NetworkInterfaceRepository, _super);
    function NetworkInterfaceRepository(networkInterfaceDao) {
        var _this = _super.call(this, networkInterfaceDao) || this;
        _this.networkInterfaceDao = networkInterfaceDao;
        return _this;
    }
    NetworkInterfaceRepository.getInstance = function () {
        if (!NetworkInterfaceRepository.instance) {
            NetworkInterfaceRepository.instance = new NetworkInterfaceRepository(new network_interface_dao_1.NetworkInterfaceDao());
        }
        return NetworkInterfaceRepository.instance;
    };
    NetworkInterfaceRepository.prototype.getNewInterfaceWithType = function (interfaceType) {
        return Promise.all([
            this.networkInterfaceDao.getNewInstance(),
            this.modelDescriptorService.getDaoForType(interfaceType.properties.objectType).then(function (dao) {
                return dao.getNewInstance();
            })
        ]).spread(function (newInterface, properties) {
            newInterface._isNewObject = true;
            newInterface._tmpId = interfaceType.type;
            newInterface.type = interfaceType.type.toUpperCase();
            newInterface.aliases = [];
            newInterface.name = '';
            newInterface[interfaceType.type] = properties;
            return newInterface;
        });
    };
    NetworkInterfaceRepository.prototype.renew = function (networkInterface) {
        return this.networkInterfaceDao.renew(networkInterface);
    };
    return NetworkInterfaceRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.NetworkInterfaceRepository = NetworkInterfaceRepository;
