"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var uuid = require("uuid");
var abstract_model_repository_1 = require("./abstract-model-repository");
var vm_datastore_dao_1 = require("../dao/vm-datastore-dao");
var VmDatastoreRepository = (function (_super) {
    __extends(VmDatastoreRepository, _super);
    function VmDatastoreRepository(vmDatastoreDao) {
        var _this = _super.call(this, vmDatastoreDao) || this;
        _this.vmDatastoreDao = vmDatastoreDao;
        return _this;
    }
    VmDatastoreRepository.getInstance = function () {
        if (!VmDatastoreRepository.instance) {
            VmDatastoreRepository.instance = new VmDatastoreRepository(new vm_datastore_dao_1.VmDatastoreDao());
        }
        return VmDatastoreRepository.instance;
    };
    VmDatastoreRepository.prototype.listDiskTargetsWithType = function (type) {
        return this.vmDatastoreDao.listDiskTargetsWithType(type);
    };
    VmDatastoreRepository.prototype.listDiskTargetsWithTypeForVm = function (type, datastoreId) {
        return this.vmDatastoreDao.listDiskTargetsWithType(type, datastoreId);
    };
    VmDatastoreRepository.prototype.getNewVmDatastoreForType = function (type) {
        return this.vmDatastoreDao.getNewInstance().then(function (datastore) {
            datastore.id = uuid.v4();
            datastore._tmpId = type;
            datastore.type = type;
            return VmDatastoreRepository.setDatastoreDefaultProperties(datastore);
        });
    };
    VmDatastoreRepository.setDatastoreDefaultProperties = function (datastore) {
        datastore.properties = datastore.properties || {};
        datastore.properties['%type'] = datastore.properties['%type'] || 'vm-datastore-' + datastore.type.toLowerCase();
        switch (datastore.type) {
            case 'NFS':
                datastore.properties.version = datastore.properties.version || 'NFSV3';
                break;
        }
        return datastore;
    };
    return VmDatastoreRepository;
}(abstract_model_repository_1.AbstractModelRepository));
exports.VmDatastoreRepository = VmDatastoreRepository;
