"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_model_repository_1 = require("./abstract-model-repository");
var docker_network_dao_1 = require("../dao/docker-network-dao");
var DockerNetworkRepository = (function (_super) {
    __extends(DockerNetworkRepository, _super);
    function DockerNetworkRepository(dockerNetworkDao) {
        var _this = _super.call(this, dockerNetworkDao) || this;
        _this.dockerNetworkDao = dockerNetworkDao;
        return _this;
    }
    DockerNetworkRepository.getInstance = function () {
        if (!DockerNetworkRepository.instance) {
            DockerNetworkRepository.instance = new DockerNetworkRepository(new docker_network_dao_1.DockerNetworkDao());
        }
        return DockerNetworkRepository.instance;
    };
    DockerNetworkRepository.prototype.getNewDockerNetwork = function () {
        return this.dockerNetworkDao.getNewInstance();
    };
    DockerNetworkRepository.prototype.listDockerNetworks = function () {
        return this.dockerNetworkDao.list();
    };
    DockerNetworkRepository.prototype.saveDockerNetwork = function (dockerNetwork) {
        return this.dockerNetworkDao.save(dockerNetwork);
    };
    DockerNetworkRepository.prototype.findNetworkWithName = function (name) {
        return this.dockerNetworkDao.find({ name: name });
    };
    DockerNetworkRepository.prototype.connectContainersToNetwork = function (containersIds, networkId) {
        return this.dockerNetworkDao.connect(networkId, containersIds);
    };
    DockerNetworkRepository.prototype.disconnectContainersFromNetwork = function (containersIds, networkId) {
        return this.dockerNetworkDao.disconnect(networkId, containersIds);
    };
    return DockerNetworkRepository;
}(abstract_model_repository_1.AbstractModelRepository));
DockerNetworkRepository.PRIMARY_NETWORK_MODES = [
    { label: 'Bridged', value: 'BRIDGED' },
    { label: 'NAT', value: 'NAT' },
    { label: 'Host', value: 'HOST' },
    { label: 'None', value: 'NONE' }
];
exports.DockerNetworkRepository = DockerNetworkRepository;
