"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstract_repository_1 = require("./abstract-repository");
var update_dao_1 = require("../dao/update-dao");
var model_1 = require("../model");
var UpdateRepository = (function (_super) {
    __extends(UpdateRepository, _super);
    function UpdateRepository(updateDao) {
        var _this = _super.call(this, [model_1.Model.Update]) || this;
        _this.updateDao = updateDao;
        return _this;
    }
    UpdateRepository.getInstance = function () {
        if (!UpdateRepository.instance) {
            UpdateRepository.instance = new UpdateRepository(new update_dao_1.UpdateDao());
        }
        return UpdateRepository.instance;
    };
    UpdateRepository.prototype.getConfig = function () {
        return this.updateDao.get();
    };
    UpdateRepository.prototype.saveConfig = function (config) {
        return this.updateDao.save(config);
    };
    UpdateRepository.prototype.getTrains = function () {
        return this.updateDao.trains();
    };
    UpdateRepository.prototype.getInfo = function () {
        return this.updateDao.updateInfo();
    };
    UpdateRepository.prototype.verify = function () {
        return this.updateDao.verify();
    };
    UpdateRepository.prototype.check = function () {
        return this.updateDao.check();
    };
    UpdateRepository.prototype.checkAndDownload = function () {
        return this.updateDao.checkfetch();
    };
    UpdateRepository.prototype.updateNow = function (reboot) {
        return this.updateDao.updatenow(reboot);
    };
    UpdateRepository.prototype.apply = function (reboot) {
        return this.updateDao.apply(reboot);
    };
    UpdateRepository.prototype.handleStateChange = function (name, data) { };
    UpdateRepository.prototype.handleEvent = function (name, data) { };
    return UpdateRepository;
}(abstract_repository_1.AbstractRepository));
exports.UpdateRepository = UpdateRepository;
