/**
 * Copyright 2017-present Palantir Technologies, Inc. All rights reserved.
 * Licensed under the MIT License (the "License"); you may obtain a copy of the
 * license at https://github.com/palantir/svg-typewriter/blob/develop/LICENSE
 */
"use strict";
var d3 = require("d3");
var DOM = (function () {
    function DOM() {
    }
    DOM.transform = function (s, x, y) {
        var xform = d3.transform(s.attr("transform"));
        if (x == null) {
            return xform.translate;
        }
        else {
            y = (y == null) ? 0 : y;
            xform.translate[0] = x;
            xform.translate[1] = y;
            s.attr("transform", xform.toString());
            return s;
        }
    };
    DOM.getBBox = function (element) {
        var bbox;
        try {
            bbox = element.node().getBBox();
        }
        catch (err) {
            bbox = {
                height: 0,
                width: 0,
                x: 0,
                y: 0,
            };
        }
        return bbox;
    };
    return DOM;
}());
exports.DOM = DOM;
//# sourceMappingURL=dom.js.map